#!/usr/bin/env python
# Title:            kFTP
# Version:          0.32
# Description:      Cool FTP Client for Personal Homepage Management
# Author:           Kong Hyeog Jun <<EMAIL: sanzio2001@hanmail.net>> 
# Home-page:        http://kftp.kldp.net
# Platform:         Linux and other Unices, needs Python 2.x
# Copying-policy:   GNU Public License
# Last Modified :   2002-11-15
# 
# This program needs python 2.x.
# 


from ftplib import FTP
import ftplib
import sys, cmd, string, os, socket
import os.path
import signal
import select
import sre as re
import time

class kFTP(cmd.Cmd):

	def __init__(self):
		cmd.Cmd.__init__(self)
		
		self.prompt = "Remote kFTP>" 
		self.ftp = FTP()             
		self.file_size = 0 
		self.mode = 2      # 2 -> Remote, 4 -> Local host
		self.updown = 5    # 5 -> download, 7 -> upload
		self.dirDB = {}   
		self.fileDB = []
		self.deep = 0   
		self.dirCnt = {}
		self.path =""
		
		print "  Welcome to kFTP 0.32!"
		self.servername ,self.userid , self.userpw = self.connection()
		self.conntime = time.time()
#################################################################
	def connection(self,ServerName=None,UserID=None,UserPW=None):
		while 1:
			try :
				if ServerName == None:
					ServerName = raw_input("- Enter Server Name:")
				print "+ connecting..."
				self.ftp.connect(ServerName)
				print "+ Connected to %s" % ServerName
			except socket.gaierror:
				print "+ No address associated with Server Name"
				ServerName = None
			else:
				break
			
		if UserID == None:
			UserID = raw_input("- Login Name:")
			if UserID == "": UserID = "anonymous"
			UserPW = raw_input("- Password  :")
			if UserPW == "": UserPW = "realuser@host"
		while 1:
			try:
				self.ftp.login(UserID,UserPW)
			except ftplib.error_perm:
				print "+ User anonymous login failed."
			else:
				break
			UserID = raw_input("- Login Name:")
			UserPW = raw_input("- Password  :")
		print "+ Login successful. Have fun!"
		self.servername ,self.userid , self.userpw = ServerName, UserID, UserPW
		return self.servername ,self.userid , self.userpw
##################################################################
	def cmdloop(self, intro=None):
		if intro is not None:
		       	self.intro = intro
		if self.intro:
		       	print self.intro
		stop = None
		while not stop:
		        if self.cmdqueue:
		        	line = self.cmdqueue[0]
		        	del self.cmdqueue[0]
		        else:
				sys.stdout.write('\r%s'%(self.prompt),)
				sys.stdout.flush()
				rfd, wfd, xfd = select.select([sys.stdin],[],[],80)
				if sys.stdin in rfd:
					line = sys.stdin.readline()
					if not len(line):
						line ='EOF'
					else:
						line = line[:-1]
				else:
					line = 'dummy'
		        stop = self.onecmd(line)
##################################################################
	def do_dummy(self,tar = None):
		try:
			self.ftp.putline("NOOP") 
			resp = self.ftp.getmultiline()
			if resp[:3] in ("530","113","421"): # 421 No Transfer Timeout, 
				self.ftp.quit()
		except:
			if self.conntime:
				print "\n+ Connection closed by timeout."
				print "+ if you want to re-connect to the same ftp server, type 're'."
				print "  if not, 'new' for new connection or 'bye' for kftp's termination."
				self.conntime = 0
##################################################################
	def do_re(self,tar = None):
		try:
			self.ftp.quit()
		except:
			pass
		print "+ starting reconnection."
		self.connection(self.servername ,self.userid , self.userpw)
		self.conntime = time.time()
##################################################################
	def do_new(self,tar = None):
		try:
			self.ftp.quit()
			print "+ current connection terminated."
		except:
			pass
		self.connection()
		self.conntime = time.time()
##############################################################################################
##################################################################				
	def do_get(self,tar):
		msg = ["+ No such file or directory.","+ The list of files and directories matched.", "- Do you wanna %s %s ?(y/n)", "download :", "- downloading..."]
		self.updown = 5
		tar,mode,flag = self.parse_05(tar, None,self.updown)
		self.parse_06(tar, mode, flag, msg, self.pgbody, None, self.getFile, self.filesDownload)

##################################################################				
	def do_put(self,tar):
		msg = ["+ No such file or directory.","+ The list of files and directories matched.", "- Do you wanna %s %s ?(y/n)", "upload :", "- uploading..."]
		self.updown = 7
		tar, mode, flag = self.parse_05(tar, None,self.updown)
		self.parse_06(tar, mode, flag, msg, self.pgbody, None, self.putFile, self.filesUpload)

##################################################################
	def filesDownload(self):
		for file in self.fileDB:
			self.getFile(file)

##################################################################
	def filesUpload(self):  
		for file in self.fileDB:
			self.putFile(file)

##################################################################
	def filesDelete(self):
		try:
			if self.mode ==2: # remote
				fun = self.ftp.delete
			elif self.mode ==4: # local 
				fun = os.remove
			for file in self.fileDB:
				fun(file)
		except:
			print "Error : Can't deleted %s"%(file)
 
##################################################################
	def pgbody(self,tar,str,flag,fun1,fun2):
		print str
		if not self.isDir(tar):  #   ̶,  ٿε
			if flag == 7: # ε
				fun1(tar)
			elif flag ==5 :        # ٿε
				fun1(tar)
		else :                   #   丮,  ٿε
			while 1 :
				self.down_dir(tar,flag)	# ش 丮 ̵
				if (flag %3) == 1:
						self.parse_02()	      #     иϿ self.dirDB self.fileDB  
						fun2()    #   ε
				else:
						self.parse_01()	        #     иϿ self.dirDB self.fileDB  
						fun2()    #   ٿε
			
				if (self.dirCnt[self.deep] > 0) :  #    ִٸ
					tar = self.dirDB[self.deep + self.dirCnt[self.deep]]
					self.dirCnt[self.deep] -= 1  
				elif (self.dirCnt[self.deep] == 0) : #   ,  ̵ϸ鼭   ϴ ƾ
					i = 1                     #  while  break   õ ӽ 
					while i :
						self.up_dir(flag)      #   ̵ 
						if(self.deep == 0):        #  ġ top̸ .
							i = 0
							break
						elif(self.dirCnt[self.deep] > 0):  #    ִٸ
							tar = self.dirDB[self.deep + self.dirCnt[self.deep]]
							self.dirCnt[self.deep] -= 1
							break                         
					if i == 0:
						break                    
		#self.ShowDir(self)

		self.fileDB =[]
		self.dirDB = {}           # 丮 
		self.deep = 0               # x  ؽ
		self.dirCnt = {}          # X   丮 
		self.path =""
##################################################################
	def putFile(self,tar):
		try:
			self.file_size = os.path.getsize(tar)
			self.ftp.voidcmd("TYPE I")
			conn = self.ftp.transfercmd("STOR "+tar) 
			f = file(tar,"r")
			flen = 0
			while 1:
				block = f.read(8192)
				if len(block) == 0:
					break
				flen = flen + len(block)
				conn.sendall(block)
				print "\r- %s Uploading :%10dbytes/%sbytes %5d%%" % (tar, flen , self.file_size,int((flen/float(self.file_size))*100)),
			print "\r- %s Uploaded  :%10dbytes/%sbytes" % (tar, flen, self.file_size)
			f.close()
			conn.close()
			self.ftp.voidresp()
			self.file_size = 0
		except:
			print "+ Can't upload : %s"%(tar)
##################################################################
	def parse_01(self,arg=None):
		cnt = 0
		self.fileDB = []
		
		resp = self.ftp.sendcmd("TYPE A")
		conn = self.ftp.transfercmd("LIST")
		fd = conn.makefile('rb')
		while 1:
			line = fd.readline()
			if len(line) == 0:
				break
			if line[-2:] == "\r\n":
				tmp = line[:-2]
			elif line[-1:] == "\n":
				tmp = line[:-1]
			tmp2 = string.split(tmp)
			if tmp2[0][0] == 'd':    # if it is a directory,
				tmp2 = self.parse_03(tmp2)
				cnt = cnt + 1
				self.dirDB[self.deep+cnt] = tmp2
			elif tmp2[0][0] == '-':  # else if it is a file
				tmp2 = self.parse_03(tmp2)
				self.fileDB.append(tmp2)
		self.dirCnt[self.deep] = cnt       # total number of sub directory
		fd.close()
		conn.close()
		self.ftp.voidresp()
####################################################################
	def parse_03(self,tar):
		if len(tar) > 9:
			end = len(tar)
			str =[]
			for y in range(8,end):
				str.append(tar[y])
			tar = string.join(str)
		else:
			tar = tar[-1]
		return tar
##################################################################
	def parse_02(self):
		self.fileDB = []
		cnt = 0
		tmp = []
		tmp = os.listdir(".")
		for tmp2 in tmp:
			if os.path.isfile(tmp2):
				self.fileDB.append(tmp2)
			elif os.path.isdir(tmp2):
				cnt = cnt + 1
				self.dirDB[self.deep+cnt] = tmp2
		self.dirCnt[self.deep] = cnt       # total number of sub directory
##################################################################		
	def getFile(self, tar):
		try:
			self.size(tar)
			self.ftp.voidcmd("TYPE I")
			flen = 0
			if os.path.isfile(tar):
				size = str(os.path.getsize(tar))
				resp = string.lower(raw_input("%s : (O)verWrite/(A)ppend/(P)ass?"%(tar)))
				if resp == "a":
					try:	
						f = file(tar,"a")
						conn = self.ftp.transfercmd("RETR "+tar, size)
						flen = int(size)
					except:
						f.close()
						print "+ FTP Restart is NOT supported on either server or client."
						return
				elif resp == "p":
					return
			if flen == 0:
				f = file(tar,"w")
				conn = self.ftp.transfercmd("RETR "+tar) 
			while 1:
				block = conn.recv(8192)
				if len(block) == 0:
					break
				flen = flen + len(block)
				f.write(block)
				print "\r- %s downloading :%10dbytes/%sbytes  %5d%%" % (tar,flen , self.file_size,int((flen/float(self.file_size))*100)),
			print "\r- %s : Downloaded  :%10dbytes/%sbytes" % (tar,flen, self.file_size)
			f.close()
			conn.close()
			self.ftp.voidresp()
			self.file_size = 0
		except:
			print "+ Can't download : %s"%(tar)
##################################################################
	def size(self, tar):
		self.file_size = 0
		try :
			resp = self.ftp.sendcmd("TYPE A")
			conn = self.ftp.transfercmd("LIST")
			fd = conn.makefile('rb')
			while 1:
				line = fd.readline()
				if len(line) == 0:
					print "+ No such file : %s" % (tar)
					break
				if line[-2:] == "\r\n":
					tmp = line[:-2]
				elif line[-1:] == "\n":
					tmp = line[:-1]
				tmp2 = string.split(tmp)
				name = self.parse_03(tmp2)
				if name == tar:
					self.file_size = int(tmp2[4])
					break
				if self.file_size != 0: break
			fd.close()
			conn.close()
			self.ftp.voidresp()
		except:
			pass
##################################################################
	def isDir(self, tar):
		dirFlag = 0
		try:
			if self.updown == 5:      # download mode
				self.ftp.cwd(tar)
				self.ftp.cwd("..")				
				dirFlag = 1  # it means that tar is Directory
			elif self.updown == 7:    # upload mode
				dirFlag = os.path.isdir(tar)
		except:
			dirFlag = 0          # it means that tar is File
		return dirFlag
##################################################################
	def up_dir(self,flag):
		if (flag%2)==1:
			self.ftp.cwd("..")
			os.chdir("..")
		elif (flag%2) == 0:
			name = self.ftp.pwd()
			self.ftp.cwd("..")
			try:
				self.ftp.rmd(name)
				print "+ %s removed"%(name)
			except:
				print "Error : Can't deleted %s"%(name)
		self.deep -= 100
		self.path = os.path.split(self.path)[0]
		print "+ Working directory changed to : %s"% (self.path)
###################################################################
	def down_dir(self,tar,flag):
		if (flag%2) == 1:	# upload $ download mode
			if flag ==5:         # download mode
				self.ftp.cwd(tar)
				try :
					os.mkdir(tar)               
				except OSError:      
					pass        
				os.chdir(tar)
				self.deep = self.deep + 100      
			elif flag ==7:       # upload mode
				os.chdir(tar)
				try :
					self.ftp.mkd(tar)
				except :                 
					pass	        
				self.ftp.cwd(tar)
				self.deep = self.deep + 100          
		else:                    # remote mode
				self.ftp.cwd(tar)
				self.deep = self.deep + 100      
		if self.path == "":
			self.path = self.ftp.pwd()
			self.path = os.path.split(self.path)[0]
		self.path = os.path.join(self.path,tar)
		print "+ Working directory changed to :: %s" %(self.path)
##############################################################################################
##################################################################
	def ShowDir(self,strarg = None):
		if self.mode == 2:
			tmp = self.ftp.sendcmd('PWD')
			print '+ %s '%(tmp[4:])
			tmp = string.split(tmp)
			return tmp[1]
		elif self.mode == 4:
			tmp = os.getcwd()
			print '+ "'+tmp+'"is current directory'
			return tmp
##################################################################		
	def do_ls(self,strarg = None):
		try:
			if self.mode == 2:
				self.ftp.retrlines('LIST')	
			elif self.mode == 4:
				os.system("ls")
			self.ShowDir()
		except:
			pass
##################################################################
	def parse_05(self, tar, mode, flag):
		dum =[]
		if tar == "":
			pass
		elif tar == os.curdir:
			dum.append(os.curdir)
		elif tar == os.pardir: 
			dum.append(os.pardir)
		else:
			foo =[]
			if mode == 4:              # rocal
				if flag == "dir":
					self.parse_02()
					foo = self.dirDB.values()
				elif flag == "file":
					self.parse_02()
					foo = self.fileDB
			elif mode == 2:            # remote
				if flag == "dir":
					self.parse_01()
					foo = self.dirDB.values()
				elif flag =="file":
					self.parse_01()
					foo = self.fileDB
			else:
				if flag == 7:
					foo = os.listdir(".")
				elif flag == 5:
					foo = self.ftp.nlst()
			p = re.compile(tar,re.IGNORECASE)
			for x in foo:
				tmp = p.match(x)
				if tmp:
					if tmp.group():
						dum.append(x)
			self.fileDB =[]
			self.dirDB = {}
			if len(dum) == 0:
				dum.append("...") # it means "No such target"
		return dum, mode, flag
##################################################################
	def parse_06(self,tar,mode,flag,msg,fun1,fun2,fun3,fun4):
		selectedNames = []
		if (len(tar) == 1):
			if tar[0] == ".":
				pass
			elif tar[0] == "...":
				print msg[0]
			elif fun2 == None:
				if mode:
					flag = mode
				fun1(tar[0],msg[4],flag,fun3,fun4)
			else :
				if mode == 4:
					fun1(tar[0])
				elif mode == 2:
					fun2(tar[0])
				print msg[4]%tar[0]
		elif(len(tar) >1):
			print msg[1]
			i = 1
			for dum in tar:
				print "  (%d) : %s" %(i, dum)
				i = i + 1
			for dum in tar:
				res = string.lower(raw_input(msg[2]%(msg[3],dum)))
				if res == "y":
					if fun2 == None:
						selectedNames.append(dum)
					else:
						if mode == 4:
							fun1(dum)
						elif mode == 2:
							fun2(dum)
						print msg[4]%(dum)
						break
			if fun2 == None:
				for dum in selectedNames:
					if mode:
						flag = mode					
					fun1(dum,msg[4],flag,fun3,fun4)
##################################################################
	def do_cd(self,path):
		try:
			msg = ["+ No such directory", "+ The list of directories matched ", "- Do you wanna %s %s ?(y/n)", "change working directory to : ", "+ Working directory changed to %s"]
			tar,mode,flag = self.parse_05(path, self.mode, "dir")
			if tar == []:
				if self.mode == 2:
					self.ftp.cwd(os.sep)
				elif self.mode == 4:
					os.system("cd ")
				self.ShowDir()
			
			else:
				self.parse_06(tar,mode,flag,msg,os.chdir,self.ftp.cwd,None,None)
		except:
			pass # when changing to .. at Top directory, try-execpt statements prevents kftp from terminating suddenly.
##################################################################
	def do_rmdir(self, path):

		tar,mode,flag = self.parse_05(path, self.mode,"dir")
		if self.mode == 2 :
			msg = ["+ No such directory.", "+ The list of directories matched", "- Do you wanna %s %s ?(y/n)", "remove : ", "+ removing..."]
			tar,mode,flag = self.parse_05(path, self.mode,"dir")
			self.parse_06(tar, mode, flag, msg, self.pgbody, None ,None ,self.filesDelete)
		elif self.mode ==4 :
			os.system("rm -rf %s"%(path))
			print "+ %s removed"%(path)	
			self.parse_06(tar, mode, flag, msg, function, None ,None ,self.filesDelete)

##################################################################	
	def do_rm(self, tar):
		try:
			msg = ["+ No such file.", "+ The list of files matched", "- Do you wanna %s %s ?(y/n)", "remove : ", "+ %s removed"]
			tar,mode,flag = self.parse_05(tar, self.mode,"file")
			self.parse_06(tar,mode,flag, msg, os.remove, self.ftp.delete,None,None)
		except:
			pass
##################################################################
	def do_mv(self,tar):
		try:
			if self.mode == 2:
				files = string.split(tar," ")
				self.ftp.rename(files[0],files[1])
			elif self.mode == 4:
				files = string.split(tar, " ")
				os.rename(files[0], files[1])
			print "+ Renamed %s to %s" %(files[0],files[1])
		except:
			pass
##################################################################
	def do_mkdir(self, path):
		try:	
			if self.mode == 2:
				resp = self.ftp.sendcmd('MKD ' + path)	 
			elif self.mode ==4:
				os.mkdir(path)
			print "+ %s : directory created!"%(path)
		except:
			pass
##################################################################	
	def do_lcd(self, strarg = None):
		print "+ Locol working directory is :"+ os.getcwd()
##################################################################	
	def do_sys(self,comm):
		try:
			if self.mode == 4:
				os.system(comm)
			else:
				print "+ Requested action not taken"
				print '+ SYS is used with "local mode".'
		except:
			pass
##################################################################
	def do_local(self,tar = None):
		self.mode = 4
		self.prompt = "Local kFTP>"
	def do_l(self, tar = None):
		self.mode = 4
		self.prompt = "Local kFTP>"
	def do_remote(self,tar = None):
		self.mode = 2
		self.prompt = "Remote kFTP>"
	def do_r(self,tar = None):
		self.mode = 2
		self.prompt = "Remote kFTP>"
##################################################################
	def do_st(self,tar = None):
		if self.conntime:
			print "-------------------------------------------------------------"
			print " Current connected server : %s" %(self.servername)
			print " Total connection times   : %.2f seconds" %(time.time()-self.conntime)
			print "-------------------------------------------------------------"
##################################################################
	def do_bye(self,tar = None):
		print "+ See ya again!"
					# self.ftp.quit()
		sys.exit()
##################################################################		
	def do_help(self,strang = None):
		print "----------------------------------------------------------------"
		print "                        kFTP commands                           "
		print "----------------------------------------------------------------"
		print " local  , l    : changes the working directory to the local host's"
		print " remote , r    : changes the working directory to the ftp server's"
		print " put [tar]     : upload the file or directory named [tar]       "
		print " get [tar]     : download the file of directory named [tar]     "
		print " cd  [path]    : changes the working directory to the given [path]" 
		print " ls            : shows the list of files and directories         "
		print " lcd           : shows the current working directory on local host"
		print " mkdir [path]  : creates the new directory named [path]        "
		print " rmdir [path]  : removes the directory named [path]            "
		print " rm    [file]  : removes the file named [file]                 "
		print " mv [frn] [ton]: renames [frn] to [ton]                        " 
		print " sys [command] : uses system command of local host             "
		print " new           : connects to the new ftp server                "
		print " re            : re-connects to the current ftp server    "
		print " st            : displays current status (hostname,etc.)       "
		print " bye           : terminate kFTP                               "
		print " about         : about kFTP                                   "
		print "----------------------------------------------------------------"
##################################################################
	def do_about(self, strang = None):
		print "-------------------------------------------------------------"
		print "   kFTP : FTP Client for Personal Homepage Management        "
		print "-------------------------------------------------------------"
		print "   Title         : kFTP                                      "
		print "   Version       : 0.32                               " 
		print "   Auther        : Kong Hyeog Jun  <sanzio2001@hanmail.net>  "
		print "   Home-page     : http://kftp.kldp.net                      "
		print "   Platform      : Linux and other Unices, needs Python 2.x  "
		print "   Copying-policy: GNU Public License                        "
		print "   Last Modified : 2002-11-15                                "
		print "                                             /Enjoy python!/ " 
		print "-------------------------------------------------------------"		                                        
##################################################################
if __name__ == "__main__":
	start = kFTP()
	start.cmdloop()
